codeforces 26C Parquet 贪心 模拟

Parquet

time limit per test2 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Once Bob decided to lay a parquet floor in his living room. The living room is of size n × m metres. Bob had planks of three types: a planks 1 × 2 meters, b planks 2 × 1 meters, and c planks 2 × 2 meters. Help Bob find out, if it is possible to parquet the living room with such a set of planks, and if it is possible, find one of the possible ways to do so. Bob doesn’t have to use all the planks.

Input
The first input line contains 5 space-separated integer numbers n, m, a, b, c (1 ≤ n, m ≤ 100, 0 ≤ a, b, c ≤  104 ), n and m — the living room dimensions, a, b and c — amount of planks 1 × 2, 2 × 1 и 2 × 2 respectively. It’s not allowed to turn the planks.

Output
If it is not possible to parquet the room with such a set of planks, output IMPOSSIBLE. Otherwise output one of the possible ways to parquet the room — output n lines with m lower-case Latin letters each. Two squares with common sides should contain the same letters, if they belong to one and the same plank, and different letters otherwise. Different planks can be marked with one and the same letter (see examples). If the answer is not unique, output any.

Examples
input
2 6 2 2 1
output
aabcca
aabdda
input
1 1 100 100 100
output
IMPOSSIBLE
input
4 4 10 10 10
output
aabb
aabb
bbaa
bbaa

题目链接

题意:你有1*2,2*1和2*2的木板各a,b,c个,然后问你能否用这些木板拼成n*m的木板。

解题思路:明显的贪心题,刚开始却不知道从何下手,可以知道的是我们肯定可以先把2*2的木板全部用完,因为没有想过可以把2*2的木板先取负,后来才想到可以,然后用余下的1*2和2*1的木板对其进行补足就好了。如果木板不足或是n*m无法整除2,那么我们就无法拼成n*m的木板。
然后之后还需要对其进行编号,因为是100*100,所以可以直接暴力找编号就好,就是比较的时候真的是烦到不行…

#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
using namespace std;
int n,m,a,b,c,st[105][105],flag=1;
char st1[105][105];
void cc(int i,int j){
    st[i][j]=st[i+1][j]=st[i][j+1]=st[i+1][j+1]=3;
}
void bb(int i,int j){
    st[i][j]=st[i+1][j]=2;
}
void aa(int i,int j){
    st[i][j]=st[i][j+1]=1;
}

void aaa(int x,int y){
    char s;
    for(char i='a';;i++){
        if(i!=st1[x-1][y]&&i!=st1[x+1][y]&&i!=st1[x][y-1]
        &&i!=st1[x][y+2]&&i!=st1[x-1][y+1]&&i!=st1[x+1][y+1]){
            s=i;
            break;
        }
    }
    st1[x][y]=st1[x][y+1]=s;
    st[x][y]=st[x][y+1]=0;
}

void bbb(int x,int y){
    char s;
    for(char i='a';;i++){
        if(i!=st1[x-1][y]&&i!=st1[x+2][y]&&i!=st1[x][y-1]
        &&i!=st1[x][y+1]&&i!=st1[x+1][y+1]&&i!=st1[x+1][y-1]){
            s=i;
            break;
        }
    }
    st1[x][y]=st1[x+1][y]=s;
    st[x][y]=st[x+1][y]=0;
}

void ccc(int x,int y){
    char s;
    for(char i='a';;i++){
        if(i!=st1[x-1][y]&&i!=st1[x-1][y+1]&&i!=st1[x][y-1]
        &&i!=st1[x][y+2]&&i!=st1[x+1][y-1]&&i!=st1[x+1][y+2]
        &&i!=st1[x+2][y]&&i!=st1[x+2][y+1]){
            s=i;
            break;
        }
    }
    st1[x][y]=st1[x][y+1]=st1[x+1][y]=st1[x+1][y+1]=s;
    st[x][y]=st[x][y+1]=st[x+1][y]=st[x+1][y+1]=0;
}
int main(){
    scanf("%d%d%d%d%d",&n,&m,&a,&b,&c);
    if((m*n)%2==1||m*n>2*a+2*b+4*c){
        printf("IMPOSSIBLE\n");
        return 0; 
    }
    c-=(m/2)*(n/2);
    for(int i=1;i<=n;i+=2){
        for(int j=1;j<=m;j+=2){
            cc(i,j);
        }
    }
    if(m%2==1){
        for(int i=1;i<=n;i+=2){
            bb(i,m);
            b--;
        }
    }
    if(n%2==1){
        for(int i=1;i<=m;i+=2){
            aa(n,i);
            a--;
        }
    }
    if(a<0||b<0){
        printf("IMPOSSIBLE\n");
        return 0; 
    }
    if(c<0){
        for(int i=1;i<=n;i++){
            for(int j=1;j<=m;j++){
                if(st[i][j]==3){
                    if(a>=2){
                        aa(i,j);
                        aa(i+1,j);
                        a-=2;
                        c++;
                    }
                    else if(b>=2){
                        bb(i,j);
                        bb(i,j+1);
                        b-=2;
                        c++;
                    }
                    else{
                        flag=0;
                        break;
                    }
                }   
                if(c==0)    break;
            }
            if(flag==0) break;
            if(c==0)    break;
        }
    }   
    if(flag==0){
        printf("IMPOSSIBLE\n");
        return 0; 
    }
    else{
        for(int i=1;i<=n;i++){
            for(int j=1;j<=m;j++){
                if(st[i][j]==0) continue;
                else if(st[i][j]==1){
                    aaa(i,j);
                }
                else if(st[i][j]==2){
                    bbb(i,j);
                }
                else if(st[i][j]==3){
                    ccc(i,j);
                }
            }
        }
        for(int i=1;i<=n;i++){
            for(int j=1;j<=m;j++)   printf("%c",st1[i][j]);
            printf("\n");
        }
    }
    return 0;   
}
内容概要:本文详细介绍了QY20B型汽车起重机液压系统的设计过程,涵盖其背景、发展史、主要运动机构及其液压回路设计。文章首先概述了汽车起重机的分类和发展历程,强调了液压技术在现代起重机中的重要性。接着,文章深入分析了QY20B型汽车起重机的五大主要运动机构(支腿、回转、伸缩、变幅、起升)的工作原理及相应的液压回路设计。每个回路的设计均考虑了性能要求、功能实现及工作原理,确保系统稳定可靠。此外,文章还详细计算了支腿油缸的受力、液压元件的选择及液压系统的性能验算,确保设计的可行性和安全性。 适合人群:从事工程机械设计、液压系统设计及相关领域的工程师和技术人员,以及对起重机技术感兴趣的高等院校学生和研究人员。 使用场景及目标:①为从事汽车起重机液压系统设计的工程师提供详细的参考案例;②帮助技术人员理解和掌握液压系统设计的关键技术和计算方法;③为高等院校学生提供学习和研究起重机液压系统设计的实用资料。 其他说明:本文不仅提供了详细的液压系统设计过程,还结合了实际工程应用,确保设计的实用性和可靠性。文中引用了大量参考文献,确保设计依据的科学性和权威性。阅读本文有助于读者深入了解汽车起重机液压系统的设计原理和实现方法,为实际工程应用提供有力支持。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值